var FirefoxCallbackDictionary = {};
var Has_Static_Images = false;

var meetings_css_url;
var jquery_ui_css_url;
var meetings_framedoc_css_url;
var calendar_colors_css_url;
var full_calendar_css_url;

var bcal_img_url;
var plus_img_url;
var show_cal_img_url;

var calendar_gif_url;
var ui_icons_png_url;

var wc_accounts_screenshot_url;
var wc_suggest_times_screenshot_url;
var wc_highlight_email_screenshot_url;
var wc_bcal_menu_screenshot_url;

var bcal_logo_png_url;
var bcal_fb_png_url;
var bcal_gplus_png_url;
var bcal_twitter_png_url;
var close_png_url;
var powered_by_yelp_png_url;

var bcal_png_url;
var group_png_url;
var availability_nextfewdays_png_url;
var availability_nextweek_png_url;

function store_authenticated_guser_address(guser){
	self.port.emit("store_email_address", {"email": guser});
}

function get_authenticated_guser_addresses(){
	self.port.emit("get_email_addresses", {});
}

self.port.on("receive_email_addresses", function(data) {
	AuthenticatedGuserAddresses = data["emails"];
});


self.port.emit("get_static_img", {});
self.port.on("return_static_img", function(data) {
	meetings_css_url = data["meetings_css"] ;
	jquery_ui_css_url = data["jquery_ui_css"];
	meetings_framedoc_css_url = data["meetings_framedoc_css"];
	calendar_colors_css_url = data["calendar_colors_css"];
	full_calendar_css_url = data["full_calendar_css"];

	bcal_img_url = data["bcal_img"];
	plus_img_url = data["plus_img"];
	show_cal_img_url = data["show_cal_img"];
	calendar_gif_url = data["calendar_gif"];
	ui_icons_png_url = data["ui_icons_png"];

	bcal_logo_png_url = data["bcal_logo_png"];
	bcal_fb_png_url = data["bcal_fb_png"];
	bcal_gplus_png_url = data["bcal_gplus_png"];
	bcal_twitter_png_url = data["bcal_twitter_png"];
	close_png_url = data["close_png"];
	powered_by_yelp_png_url = data["powered_by_yelp_png"];

	bcal_png_url = data["bcal_png"];
	group_png_url = data["group_png"];
	availability_nextfewdays_png_url = data["availability_nextfewdays_png"];
	availability_nextweek_png_url = data["availability_nextweek_png"];

	wc_accounts_screenshot_url = data["wc_accounts_screenshot_url"];
	wc_suggest_times_screenshot_url = data["wc_suggest_times_screenshot_url"];
	wc_highlight_email_screenshot_url = data["wc_highlight_email_screenshot_url"];
	wc_bcal_menu_screenshot_url = data["wc_bcal_menu_screenshot_url"];

	Has_Static_Images = true;
	inject_gmail_css();
});

function inject_gmail_css(){
	var headID = document.getElementsByTagName("head")[0];
	var cssNode = document.createElement('link');
	cssNode.type = 'text/css';
	cssNode.rel = 'stylesheet';
	cssNode.href = jquery_ui_css_url;
	cssNode.media = 'screen';
	headID.appendChild(cssNode);

	var cssNode = document.createElement('link');
	cssNode.type = 'text/css';
	cssNode.rel = 'stylesheet';
	cssNode.href = meetings_css_url;
	cssNode.media = 'screen';
	headID.appendChild(cssNode);
}


function get_bcal_logo_url(){
	return bcal_img_url;
}

function get_calendar_icon_url(){
	return show_cal_img_url;
}

function get_bcal_plus_url(){
	return plus_img_url;
}

function get_bcal_css_url(){
	return meetings_framedoc_css_url;
}


function get_bcal_datepicker_icon_url(){
	return calendar_gif_url;
}

function get_bcal_jquery_icons_url(){
	return ui_icons_png_url;
}


function get_wc_accounts_screenshot_url(){
	return "https://s3.amazonaws.com/BoomerangCalendar/images/google_accounts_screenshot.png";
}
function get_wc_suggest_times_screenshot_url(){
	return wc_suggest_times_screenshot_url;
}
function get_wc_highlight_email_screenshot_url(){
	return wc_highlight_email_screenshot_url;
}
function get_wc_bcal_menu_screenshot_url(){
	return wc_bcal_menu_screenshot_url;
}

function get_third_party_cookies_help_link(){
	return "http://support.mozilla.org/en-US/kb/Disabling%20third%20party%20cookies";
}


function get_bcal_twitter_icon_url(){
	return bcal_logo_png_url;
}
function get_bcal_facebook_icon_url(){
	return bcal_fb_png_url;
}
function get_bcal_gplus_icon_url(){
	return bcal_gplus_png_url;
}
function get_bcal_close_icon_url(){
	return close_png_url;
}
function get_bcal_big_logo_url(){
	return bcal_logo_png_url;
}

function get_yelp_logo_url(){
	return powered_by_yelp_png_url;
}

function get_insert_meeting_url(){
	return bcal_png_url;
}
function get_insert_group_meeting_url(){
	return group_png_url;
}
function get_nextfewdays_availability_url(){
	return availability_nextfewdays_png_url;
}
function get_nextweek_availability_url(){
	return availability_nextweek_png_url;
}


function get_root_document_css_urls() {
	return [
		calendar_colors_css_url,
		meetings_css_url,
		jquery_ui_css_url,
		full_calendar_css_url
	];
}

function get_jquery_ui_css_url(){
	return jquery_ui_css_url;
}
function get_timezone_data_urls() {
	return {
        offsets: "https://boomerangcalendar.baydin.com/site_media/timezone/offset-to-conical.min.json",
        info: "https://boomerangcalendar.baydin.com/site_media/timezone/timezone-info.min.json"
	};
}

function only_call_function_if_this_tab_is_active(callback){
	var callbackId = Date.now();
	FirefoxCallbackDictionary[callbackId] = callback;
	self.port.emit("active_tab", {"callbackId": callbackId, "guser": get_gmail_user()});
}

function send_get_request_auth_wrapper(url, callback) {
	send_get_request(url, callback, true, false);
};

function send_get_request_silent_auth_wrapper(url, callback) {
	send_get_request(url, callback, true, true);
};


self.port.on("response_from_get_request", function(data) {
	var callbackId = data["callbackId"];
	var callback = FirefoxCallbackDictionary[callbackId];


	var responseStatus = data["responseStatus"];
	var responseText = data["responseText"];
	var shouldAuthAndRetry = data["shouldAuthAndRetry"];
	var shouldBeSilent = data["shouldBeSilent"];
	var url = data["url"];


	if (responseStatus == 200){
		callback(responseText);
	}
	else if (responseStatus == 403){
		if (shouldAuthAndRetry){
			oauth_flow(url, callback, shouldBeSilent);
		}
		else if(!shouldBeSilent)
		{
			show_authentication_error();
		}
	}
	else{
		if (!shouldBeSilent){
			show_dialog("An unknown error occurred. Please try again, and check that you have at least one Google Calendar. If still unsuccessful, contact support@baydin.com for assistance.");
		}
	}
});

function send_get_request(url, callback, shouldAuthAndRetry, shouldBeSilent)
{
	var callbackId = Date.now();
	FirefoxCallbackDictionary[callbackId] = callback;
	self.port.emit("send_get_request", {"callbackId": callbackId, "url": url, "shouldAuthAndRetry": shouldAuthAndRetry, "shouldBeSilent": shouldBeSilent});
}

function oauth_flow(url, callback, shouldBeSilent)
{
	var guser = get_gmail_user();
	if (guser == null || guser.indexOf("@") == -1){
		return;
	}

	var callbackId = Date.now();
	FirefoxCallbackDictionary[callbackId] = function(){send_get_request(url, callback, false, shouldBeSilent);};
	self.port.emit("auth_popup", {"callbackId": callbackId, "authurl": "https://boomerangcalendar.baydin.com/login?guser=" + guser,
								 "shouldBeSilent": shouldBeSilent});

}


self.port.on("call_function", function(data) {
	var callbackId = data["callbackId"];
	var callback = FirefoxCallbackDictionary[callbackId];
	callback();
});


function browser_specific_remove_availability_hover(){
	var frameDoc = get_frame();
	$(frameDoc).mouseenter(function(){$("#b4c_availability").remove(); $(frameDoc).unbind('mouseenter');})
}

function create_popup(url)
{
	self.port.emit("popup", {"url": url});
}


var b4c_is_chrome = false;


