
Has_Static_Images = true; //always true in Chrome

function get_bcal_logo_url(){
	return chrome.extension.getURL("img/bcal16.png");
}

function get_calendar_icon_url(){
	return chrome.extension.getURL("img/show_cal.jpg");
}

function get_bcal_plus_url(){
	return chrome.extension.getURL("img/plus.jpg");
}

function get_wc_accounts_screenshot_url(){
	return "https://s3.amazonaws.com/BoomerangCalendar/images/google_accounts_screenshot.png";
}
function get_wc_suggest_times_screenshot_url(){
	return chrome.extension.getURL("img/wc_suggest_times.png");
}
function get_wc_highlight_email_screenshot_url(){
	return chrome.extension.getURL("img/wc_highlight_email.png");
}
function get_wc_bcal_menu_screenshot_url(){
	return chrome.extension.getURL("img/wc_bcal_menu.png");
}
function get_bcal_datepicker_icon_url(){
	return chrome.extension.getURL("img/calendar.gif");
}
function get_bcal_jquery_icons_url(){
	return chrome.extension.getURL("img/ui-icons.png");
}
function get_bcal_twitter_icon_url(){
	return chrome.extension.getURL("img/bcal_twitter.png");
}
function get_bcal_facebook_icon_url(){
	return chrome.extension.getURL("img/bcal_fb.png");
}
function get_bcal_gplus_icon_url(){
	return chrome.extension.getURL("img/bcal_gplus.png");
}
function get_bcal_close_icon_url(){
	return chrome.extension.getURL("img/close.png");
}
function get_bcal_big_logo_url(){
	return chrome.extension.getURL("img/bcal-logo.png");
}
function get_bcal_css_url(){
	return chrome.extension.getURL("css/meetings-framedoc.css");
}
function get_yelp_logo_url(){
	return chrome.extension.getURL("img/Powered_By_Yelp_White.png");
}
function get_insert_meeting_url(){
	return chrome.extension.getURL("img/bcal.png");
}
function get_insert_group_meeting_url(){
	return chrome.extension.getURL("img/group.png");
}
function get_nextfewdays_availability_url(){
	return chrome.extension.getURL("img/insert2days-flat.png");
}
function get_nextweek_availability_url(){
	return chrome.extension.getURL("img/insertweek-flat.png");
}
function get_root_document_css_urls() {
	return [
		chrome.extension.getURL("css/calendar-colors.css"),
		chrome.extension.getURL("css/meetings.css"),
		chrome.extension.getURL("css/jquery-ui.css"),
		chrome.extension.getURL("css/fullcalendar.css")
	];
}

function get_jquery_ui_css_url(){
	return chrome.extension.getURL("css/jquery-ui.css");
}

function get_third_party_cookies_help_link(){
	return "https://support.google.com/chrome/bin/answer.py?hl=en&answer=95647";
}

function get_timezone_data_urls() {
	return {
		offsets: "https://boomerangcalendar.baydin.com/site_media/timezone/offset-to-conical.min.json",
		info: "https://boomerangcalendar.baydin.com/site_media/timezone/timezone-info.min.json"
	};
}

function store_authenticated_guser_address(guser){
}

function get_authenticated_guser_addresses(){

}



function only_call_function_if_this_tab_is_active(callback){
	chrome.extension.sendRequest({action: "active_tab"}, function(tabs){
		if (tabs["active"]){
			callback();
		}
	});
}

function send_get_request_auth_wrapper(url, callback) {
	send_get_request(url, callback, true, false);
}

function send_get_request_silent_auth_wrapper(url, callback) {
	send_get_request(url, callback, true, true);
}


function send_get_request(url, callback, shouldAuthAndRetry, shouldBeSilent)
{
	var xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function(data) {
		if (xhr.readyState === 4) {
			if (xhr.status === 200)
			{
				callback(xhr.responseText);
			}
			else if (xhr.status === 403)
			{
				if (shouldAuthAndRetry){
					oauth_flow(url, callback, shouldBeSilent);
				}
				else if(!shouldBeSilent)
				{
					show_authentication_error();
				}
			}
			else
			{
				if(!shouldBeSilent){
					show_dialog("An unknown error occurred. Please try again, and check that you have at least one Google Calendar. If still unsuccessful, contact support@baydin.com for assistance.");
				}
			}
		}
	};
	xhr.open('GET', url, true);
	xhr.send();
}

function create_popup(url)
{
	chrome.extension.sendRequest(
		{
				'action': 'popup',
				'url': url,
		}, function(){});
}

function oauth_flow(url, callback, shouldBeSilent)
{
	var guser = get_gmail_user();
	if (guser == null || guser.indexOf("@") === -1){
		return;
	}
	chrome.extension.sendRequest(
		{
				'action': 'auth_popup',
				'authurl': "https://boomerangcalendar.baydin.com/login?guser=" + guser,
				'top': 0,
				'left': 0,
				'width': 800,
				'height': 800,
				'silent': shouldBeSilent,
		}, onAuthWindowClosed);
	function onAuthWindowClosed(request)
	{
		send_get_request(url, callback, false, shouldBeSilent);
	}
}

function browser_specific_remove_availability_hover(){
	$("#b4c_availability").remove();
}

var b4c_is_chrome = true;