// The contents of the following function will be ran in the context of the native document.
// In other words the code will be ran outside of the extension/add-on sandbox.
// Can't use jquery.
setTimeout(function() {
	execute_javascript_on_document(function() {
		window.by = window.by || {};

		(function(exports) {
			function get_frame() {
				var oIframe = document.getElementById("canvas_frame");
				if (oIframe){
					var frameDoc = (oIframe.contentWindow || oIframe.contentDocument);
					if (frameDoc.document) { frameDoc = frameDoc.document; }

					return frameDoc;
				}

				return document;
			}

			exports.get_frame = get_frame;
		})(window.by);

		(function(exports) {
			var _range;

			function store(wnd) {
				wnd = wnd || window;
				doc = wnd.document;

				if (wnd.getSelection) {
					var sel = wnd.getSelection();
					if (sel.getRangeAt && sel.rangeCount) {
						_range = sel.getRangeAt(0);
					}
				} else if (doc.selection && doc.selection.createRange) {
					_range = doc.selection.createRange();
				}

				return _range;
			}

			function restore(wnd) {
				if(!_range) { return; }

				wnd = wnd || window;
				doc = wnd.document;

				if (wnd.getSelection) {
					var sel = wnd.getSelection();
					sel.removeAllRanges();
					sel.addRange(_range);
				} else if (doc.selection && _range.select) {
					_range.select();
				}

				var tmp = _range;
				_range = null;

				return tmp;
			}

			exports.store = store;
			exports.restore = restore;
		})(window.by.selection || (window.by.selection = {}));
	});
}, 5000)