/*
 * jQuery replaceText - v1.1 - 11/21/2009
 * http://benalman.com/projects/jquery-replacetext-plugin/
 * 
 * Copyright (c) 2009 "Cowboy" Ben Alman
 * Dual licensed under the MIT and GPL licenses.
 * http://benalman.com/about/license/
 */
(function($){$.fn.replaceText=function(b,a,c){return this.each(function(){var f=this.firstChild,g,e,d=[];if(f){do{if(f.nodeType===3){g=f.nodeValue;e=g.replace(b,a);if(e!==g){if(!c&&/</.test(e)){$(f).before(e);d.push(f)}else{f.nodeValue=e}}}}while(f=f.nextSibling)}d.length&&$(d).remove()})}})(jQuery);
// http://stackoverflow.com/questions/2218999/remove-duplicates-from-an-array-of-objects-in-javascript
function array_contains(arr, val, equals) {
    var i = arr.length;
    while (i--) {
        if ( equals(arr[i], val) ) {
            return true;
        }
    }
    return false;
}

function remove_duplicates(arr, equals) {
    var originalArr = arr.slice(0);
    var i, len, j, val;
    arr.length = 0;

    for (i = 0, len = originalArr.length; i < len; ++i) {
        val = originalArr[i];
        if (!array_contains(arr, val, equals)) {
            arr.push(val);
        }
    }
}

function meeting_times_are_equal(thing1, thing2) {
    return thing1["startTime"].valueOf() == thing2["startTime"].valueOf();
}


// source: http://dreaminginjavascript.wordpress.com/2008/08/22/eliminating-duplicates/
function eliminateDuplicatesAndNull(inputArray) {
  if (inputArray == null){
	return [];
  }

  var i;
  var outputArray=[];
  var obj={};

  for (i=0;i<inputArray.length;i++) {
    obj[inputArray[i]]=0;
  }
  for (i in obj) {
	if (i != null && i != "null"){
		outputArray.push(i);
	}
  }
  return outputArray;
}
/**
* hoverIntent r6 // 2011.02.26 // jQuery 1.5.1+
* <http://cherne.net/brian/resources/jquery.hoverIntent.html>
* 
* @param  f  onMouseOver function || An object with configuration options
* @param  g  onMouseOut function  || Nothing (use configuration options object)
* @author    Brian Cherne brian(at)cherne(dot)net
*/
(function($){$.fn.hoverIntent=function(f,g){var cfg={sensitivity:1,interval:500,timeout:0};cfg=$.extend(cfg,g?{over:f,out:g}:f);var cX,cY,pX,pY;var track=function(ev){cX=ev.pageX;cY=ev.pageY};var compare=function(ev,ob){ob.hoverIntent_t=clearTimeout(ob.hoverIntent_t);if((Math.abs(pX-cX)+Math.abs(pY-cY))<cfg.sensitivity){$(ob).unbind("mousemove",track);ob.hoverIntent_s=1;return cfg.over.apply(ob,[ev])}else{pX=cX;pY=cY;ob.hoverIntent_t=setTimeout(function(){compare(ev,ob)},cfg.interval)}};var delay=function(ev,ob){ob.hoverIntent_t=clearTimeout(ob.hoverIntent_t);ob.hoverIntent_s=0;return cfg.out.apply(ob,[ev])};var handleHover=function(e){var ev=jQuery.extend({},e);var ob=this;if(ob.hoverIntent_t){ob.hoverIntent_t=clearTimeout(ob.hoverIntent_t)}if(e.type=="mouseenter"){pX=ev.pageX;pY=ev.pageY;$(ob).bind("mousemove",track);if(ob.hoverIntent_s!=1){ob.hoverIntent_t=setTimeout(function(){compare(ev,ob)},cfg.interval)}}else{$(ob).unbind("mousemove",track);if(ob.hoverIntent_s==1){ob.hoverIntent_t=setTimeout(function(){delay(ev,ob)},cfg.timeout)}}};return this.bind('mouseenter',handleHover).bind('mouseleave',handleHover)}})(jQuery);


/*! Copyright (c) 2010 Brandon Aaron (http://brandonaaron.net)
 * Licensed under the MIT License (LICENSE.txt).
 *
 * Version 1.1
 */

(function($) {

$.fn.overlaps = function(selector) {
    // if nothing is passed, act as a filter
    if (arguments.length === 0) {
        return this.pushStack(filterOverlaps(this));
    }
    // otherwise compare selected elements against passed eleemnts
    else {
        return isOverlapping(this, $(selector));
    }
};

$.expr[':'].overlaps = function(elem, i, m, array) {
    return isOverlapping([elem], array);
};
$.expr[':'].overlapping = $.expr[':'].overlaps;

function filterOverlaps(collection) {
    var dims   = getDims(collection),
        stack  = [],
        index1 = 0,
        index2 = 0,
        length = dims.length;
    
    for (; index1 < length; index1++) {
        for (index2 = 0; index2 < length; index2++) {
            if (index1 === index2) { 
                continue;
            }
            if (checkOverlap(dims[index1], dims[index2])) {
                stack.push(collection[index2]);
            }
        }
    }
    
    return $.unique(stack);
}

function isOverlapping(collection1, collection2) {
    var dims1   = getDims(collection1),
        dims2   = getDims(collection2),
        index1  = 0,
        index2  = 0,
        length1 = dims1.length,
        length2 = dims2.length;

    for (; index1 < length1; index1++) {
        for (index2 = 0; index2 < length2; index2++) {
            if (collection1[index1] === collection2[index2]) {
                continue;
            }
            if (checkOverlap(dims1[index1], dims2[index2])) {
                return true;
            }
        }
    }
    
    return false;
}

function getDims(elems) {
    var dims = [], i = 0, offset, elem;
    
    while ((elem = elems[i++])) {
        offset = $(elem).offset();
        dims.push([
            offset.top,
            offset.left,
            elem.offsetWidth,
            elem.offsetHeight
        ]);
    }
    
    return dims;
}

function checkOverlap(dims1, dims2) {
    var x1 = dims1[1], y1 = dims1[0],
        w1 = dims1[2], h1 = dims1[3],
        x2 = dims2[1], y2 = dims2[0],
        w2 = dims2[2], h2 = dims2[3];
    return !(y2 + h2 < y1 || y1 + h1 < y2 || x2 + w2 < x1 || x1 + w1 < x2);
}

})(jQuery);
