window.by = window.by || {};

(function($, exports) {
	var suggestMeeting = {
		dialog:
			'<div class="b4c-suggested-times">' +
				'<div class="b4c-suggest-meeting-controls">' +
					'<div class="b4c-generate-controls">' +
						'<div class="b4c-generate-intro">' +
							'<button id="b4c-go-to-generate-meeting" title="Feeling lucky? Let Boomerang generate an ideal meeting time for you."><img style="vertical-align:middle;" src="https://s3.amazonaws.com/BoomerangCalendar/images/bcaldie_dots.png"></button>' +
						'</div>' +
						'<div class="b4c-meeting-title-container">' +
							'<span class="b4c-field-name b4c-meeting-title-header">Title: </span>' +
							'<div class="by-error-message">This is an error message</div>' +
							'<label><input type="text" id="b4c-meeting-title" class="by-input-primary" placeholder="Meeting Title (optional)"/></label>' +
							'<label class="b4c-tentative-container"><input type="checkbox" id="b4c-mark-tentative"/> <span>Reserve these time slots in my calendar</span> </label>' +
							'<span bcal-title="Boomerang Calendar can add the times you suggested to your calendar and mark them as tentative. When you confirm one of the times and add the meeting to your calendar, we\'ll prompt you to clear the other times." class="by-icon by-icon-info"/>' +
						'</div>' +
						'<span class="b4c-field-name b4c-meeting-length-title">How long: </span>' +
						'<div class="b4c-meeting-length by-buttonset">' +
								'<input type="radio" name="meeting-length" id="b4c-15min" value="15"/><label for="b4c-15min">15 min</label>' +
								'<input type="radio" name="meeting-length" id="b4c-30min" value="30"/><label for="b4c-30min">30 min</label>' +
								'<input type="radio" name="meeting-length" id="b4c-45min" value="45"/><label for="b4c-45min">45 min</label>' +
								'<input type="radio" name="meeting-length" id="b4c-1hour" value="60"/><label for="b4c-1hour">1 hour</label>' +
								'<input type="radio" name="meeting-length" id="b4c-custom-length" value="custom" checked/><label for="b4c-custom-length">custom</label>' +
						'</div>' +
						'<div class="b4c-random-generator">' +
							'<h3>Generate a meeting for:</h3>' +
							'<div class="b4c-meeting-options by-buttonset">' +
								'<input type="checkbox" name="meeting-option" id="breakfast" value="breakfast"/><label for="breakfast">Breakfast</label>' +
								'<input type="checkbox" name="meeting-option" id="lunch" value="lunch"/><label for="lunch">Lunch</label>' +
								'<input type="checkbox" name="meeting-option" id="dinner" value="dinner"/><label for="dinner">Dinner</label>' +
								'<input type="checkbox" name="meeting-option" id="coffee" value="coffee" checked/><label for="coffee">Coffee</label>' +
								'<input type="checkbox" name="meeting-option" id="drinks" value="drinks"/><label for="drinks">Drinks</label>' +
								'<span class="b4c_yelp_logo"><a href="http://yelp.com"><img src="https://s3.amazonaws.com/BoomerangCalendar/images/yelp.png" alt="Powered by Yelp"/></a></span>' +
							'</div>' +
							'<div>' +
								'in <input type="text" placeholder="Enter meeting location" class="b4c-meeting-location by-input-primary"/>' +
								'<button class="by-button-secondary b4c-randomize-meeting">Try again</button>' +
							'</div>' +
						'</div>' +
						'<div class="b4c-confirm-times">' +
							'<div class="b4c-proposed-location">' +
								'<span class="b4c-field-name">Location/Phone/Online: </span>' +
								'<span class="b4c-location-text-container">Let\'s meet at <span id="b4c-location-meeting-draft-output"><a class="b4c-location-text" href="#"/></span></span> ' +
								'<input type="text" id="b4c_place_autocomplete" class="b4c-edit-location-text by-input-primary" placeholder="Location/Phone/Online (optional)" /> ' +
								'<input type="hidden" id="b4c_location_type" />' +
								'<input type="hidden" id="b4c_places_field" />' +
								'<input type="hidden" id="b4c_places_name" />' +
								'<input type="hidden" id="b4c_places_parity" />' +
								'<input type="hidden" id="b4c_generated_prepended_text" />' +
								'<input type="hidden" id="b4c_generated_inserted_text" />' +
								'<div style="display:none;" id ="b4c_places_draft_output"></div>' +
								'<a class="by-link-highlight b4c-reroll-venue" href="#">different place</a>' +
								'<ul class="b4c-locationSuggestions">' +
									'<li class="by-menu-separator"><hr></li>' +
									'<li class="by-location-add-phone by-location-add">Add Phone</li>' + 
									'<li class="by-location-add-online by-location-add">Add Online Meeting</li>' +
								'</ul>' +
							'</div>' +
							'<span class="b4c-field-name">When: </span>' +
							'<div class="b4c-proposed-times"></div>' +
							'<div>' +
								'<a href="#" class="b4c-add-time">+ Add time slot</a>' +
							'</div>' +
							'<div class="visualcalendar-block">' +
								'<label>' +
									'<input id="b4c-use-visualcalendar-cb" type="checkbox" value="1" /> Allow recipient to confirm with one click' +
								'</label>' +
									'<span class="by-icon by-icon-info" bcal-title="Boomerang Calendar will display the proposed times on a calendar, providing an easier experience for the recipient."/>' +
								'<br>' +
								'<label id="b4c-include-freebusy-label">' +
									'<input id="b4c-include-freebusy-cb" type="checkbox" value="1" /> Include my availability' +
								'</label>' +
								'<span id="b4c-include-freebusy-help" class="by-icon by-icon-info" bcal-title="In addition to the times you propose, Boomerang Calendar can show the times you\'re busy so your recipient can propose alternative times that work for you"/>' +
							'</div>' +
							'<div class="b4c-suggest-error by-error-message">This is an error message</div>' +
							'<div class="b4c-insert-buttons">' +
								'<button class="by-button-primary b4c-insert-content">Insert into email</button>' +
								'<button class="b4c-button-cancel">Cancel</button>' +
							'</div>' +
						'</div>' +
					'</div>' +
					'<div class="b4c-calendar-container">' +
						'<div class="by-widget-overlay"/>' +
							'<div class="b4c-hint-overlay">Click to Select Time Slots</div>' +
							'<div id="b4c-calendar-display"/>' +
					'</div>' +
				'</div>' +
			'</div>'
		,
		proposedTime:
			'<span class="b4c-proposed-time">' +
				'<span class="b4c-time-goto">' +
					'<span class="b4c-event-time"/>' +
					//'<a class="by-link-highlight b4c-reroll-time" href="#">different time</a>' +
					'<a class="b4c-time-remove by-icon by-icon-closewhite" href="javascript:void(0);">X</a>' +
				'</span>' + 
			'</span>'
		,
		locationSuggestion: 
			'<li class="b4c-suggested-location-history">' +
				'<span class="b4c-suggested-location-text"></span> ' + 
				'<span class="b4c-suggested-location-remove">X</span>' + 
			'</li>'
	};

	var addEvent =
		'<div class="bcal_dialogdiv">' +
			'<div id="b4c_add_event" class="b4c_add_event">' +
				'<label class="b4c-add-to-calendar">' +
					'Add to calendar: ' +
					'<select id="b4c_select_calendar"></select>' +
				'</label>' +
				'<div class="b4c_add_event_content">' +
					'<div class="by-error-message">This is an error message</div>' +
					'<div class="b4c-highlighted-field">' +
						'<label>' +
							'<span class="b4c-field-name">Title: </span>' +
							'<span><input id="b4c_event_title" name="new_event[title]" class="by-input-primary" type="text" value="Meeting with {email sender}"/></span>' +
						'</label>' +
						'<div class="b4c-date-fields">' +
							'<label for="start_date_input" class="b4c-field-name">When: </label>' +
							'<input id="start_date_input" type="text" name="start_date" class="b4c-date-input by-input-primary" size="14"/>' +
							'<label for="start_date_input" class="by-icon by-icon-calpicker">Calendar</label>' +
							'<input id="start_time_input" name="start_time" class="b4c-time-input by-input-primary" size="10"/>' +
							'<span class="b4c-date-separator by-input-primary">&ndash;</span>' +
							'<input id="end_time_input" type="text" name="end_time" class="b4c-time-input by-input-primary" size="10" />' +
							'&nbsp; &nbsp;' +
							'<a href="#" class="b4c-show-end-date by-link-highlight">Change end date</a>' +
							'<span id="end_date" class="b4c-end-date">' +
								'<input id="end_date_input" type="text" name="end_date" class="b4c-date-input by-input-primary" size="14" />' +
								'<label for="end_date_input" class="by-icon by-icon-calpicker">Calendar</label>' +
							'</span>' +
						'</div>' +
						"<div><label class='b4c-field-name'>Time Zone: </label><select id='b4c_timezone' style='margin-top: 12px;'>" +
						     "<option selected value='Local'>Local Time</option>" +
						     "<option value='Pacific'>Pacific Time</option>" +
						     "<option value='Mountain'>Mountain Time</option>" +
						     "<option value='Central'>Central Time</option>" +
						     "<option value='Eastern'>Eastern Time</option>" +
							 "</select></div>" +
					'</div>' +
					'<label>' +
						'<span class="b4c-field-name">Where: </span>' +
						'<span id="meeting_place"><input id="meeting_place_input" class="by-input-secondary"/></span>' +
					'</label>' +
					'<label>' +
						'<span class="b4c-field-name">Note: </span>' +
						'<span id="meeting_note"><textarea id="meeting_note_input" rows="5" class="by-input-secondary"/></span>' +
					'</label>' +
					'<div class="add-event-options">' +
                                                // TODO: fix inline style
						'<div style="margin-top:5px; margin-bottom:5px;">' +
							'<input id="b4c_boomerang_cb" type="checkbox" value="0"/> ' +
							'Boomerang this back to inbox ' +
							'<select id="b4c_boomerang_select">' +
								'<option value="2 hrs before">2 hours before the event</option>' +
								'<option value="4 hrs before">4 hours before the event</option>' +
								'<option value="day of">the morning of the event</option>' +
								'<option selected value="a day before">one day before</option>' +
								'<option value="a week before">one week before</option>' +
								'<option value="a month before">one month before</option>' +
							'</select>' +
						'</div>' +
                                                // TODO: fix inline style
						'<div style="margin-top:5px; margin-bottom:5px;">' +
							'<input id="b4c_reminder_cb" type="checkbox" value="0"/> ' +
							'<span class="by-icon by-icon-addpeep">attendees</span>' +
							'Remind attendees by email ' +
							'<select id="b4c_reminder_select">' +
								'<option value="2 hrs before">2 hours before the event </option>' +
								'<option value="4 hrs before">4 hours before the event</option>' +
								'<option value="day of">the morning of the event</option>' +
								'<option selected value="a day before">one day before</option>' +
								'<option value="a week before">one week before</option>' +
								'<option value="a month before">one month before</option>' +
							'</select>' +
						'</div>' +
						'<label>' +
							'<input id="b4c_google_invite_cb" type="checkbox" value="0"/> ' +
							'<span class="by-icon by-icon-addpeep">attendees</span>' +
							'Send Google Calendar Invitation to attendees' +
						'</label>' +
					'</div>' +
					'<div style="display:none;" id="b4c_attendee_emails">' +
						'<div style="display:none" id="b4c_default_attendee_emails">The attendees go here.</div>' +
						'<div id="b4c_inputted_attendee_emails">The attendees go here.</div>' +
						'<div id="b4c_more_attendee_emails">' +
							'<span><a href="#" id="b4c_add_more_attendees_button">Add more</a></span>' +
							'<span><input style="display:none;" id="b4c_more_attendee_emails_input" placeholder="Enter email address(es)" /></span>' +
						'</div>' +
					'</div>' +
					'<input type="hidden" id="b4c_email_date" />' +
					'<input type="hidden" id="b4c_thread_id" />' +
				'</div>' +
			'</div>' +
			'<div class="b4g-dialog-footer">' +
				'<button class="by-button-primary b4c-button-confirm" id="b4c_add_event_dialog_button"> Add Event </button>' +
				'<button class="b4c-button-cancel" id="b4c_add_event_cancel_button"> Cancel </button>' +
			'</div>' +
		'</div>'
	;

	var eventTooltip =
		'<div class="b4c-event-details">' +
			'<a class="by-icon by-icon-closethick" href="#"/>' +
			'<h4 class="b4c-event-title" />' +
			'<div class="b4c-event-timespan"></div>' +
			'<div class="b4c-event-calendar">Calendar: <span class="b4c-event-calendar" /></div>' +
			'<div class="b4c-event-delete-block"><a class="b4c-event-delete" href="javascript:void(0);">Remove Proposed Time</a></div>' +
		'</div>'
	;

	var customDateTimeSettings =
		"<div class='bcal_dialogdiv'>" +
			"<h4>Let's customize how you would like to write dates and times.</h4>" +
			"<div class='b4c-field'>"+
			"<span class='b4c-field-label'>Select a date format</span>" +
			"<span class='b4c-field-input'>" +
			"<select class='customDateFormat updateSampleFormat by-input-primary'>" +
				"<option id='customDate1' value='dddd, MMM d' dropdownTextFormat='MMM d'></option>" +
				"<option id='customDate2' value='dddd, M/d' dropdownTextFormat='M/d'></option>" +
				"<option id='customDate3' value='dddd, d MMM' dropdownTextFormat='d MMM'></option>" +
				"<option id='customDate4' value='dddd, d/M' dropdownTextFormat='d/M'></option>" +
			"</select>" +
			"</span>" +
			"</div>" +
			"<div style='clear:both'></div>" +
			"<br />" +
			"<div class='b4c-field'>"+
			"<span class='b4c-field-label'>Select a time format</span>" +
			"<span class='b4c-field-input'>" +
				"<select class='customTimeFormat updateSampleFormat by-input-primary'>" +
					"<option id='customTime1' value='h:mm tt' dropdownTextFormat='h:mm tt'></option>" +
					"<option id='customTime2' value='H:mm' dropdownTextFormat='H:mm'></option>" +
				"</select>" +
			"</span>" +
			"</div>" +
			"<div style='clear:both'></div>" +
			"<br />" +
			"<div class='b4c-field'>"+
			"<span class='b4c-field-label'>&nbsp;</span>" +
			"<span class='b4c-field-input'>" +
				"<input class='customTimeZone pref updateSampleFormat by-input-primary' checked='checked' type='checkbox' name='customTimeZone' value='True' />" +
				"<span>Include time zone (EST, GMT, etc.)</span>" +
			"</span>" +
			"</div>" +
			"<div style='clear:both'></div>" +
			"<div class='b4c-field'>" +
				"<span class='b4c-datetime-sample'>Sample event text in your format: <span id='sampleText'></span> </span>" +
			"</div>" +
			"<div style='clear:both'></div>" +
			"<br/>" +
			"<div>Note: if you ever want to change this setting, go to Boomerang Calendar &gt; Settings </div>" +
			'<div class="b4g-dialog-footer">' +
				'<button class="by-button-primary b4c-button-confirm" id="customFormatContinue"> Continue </button>' +
			'</div>' +
		"</div>"
	;
	var syncSettings = 	"<div>" +
		"<p>" +
			"<table id='b4c_calendar_list' class='b4c_sync_list' >" +
				"<tr>" +
				"<td colspan=2>" +
				"<strong>Select which calendars you'd like to sync with Boomerang Calendar.</strong>" +
				"</td>" +
				"</tr>" +
			"</table>" +
		"</p>" +
		"<div class='b4c-field'>" +
			"<label>" +
				"<span class='b4c-field-label'> Default calendar to add events</span>" + 
				"<span class='b4c-field-input'>" + 
					"<select id='def_calendar' class='b4c_def_list'>" +
					"</select>" +
				"</span>" +
			"</label>" +
		"</div>" +
	"</div>";
	var allSettings = 
	"<div class='bcal_dialogdiv'>" +
		"<label>" +
			"<span class='b4c-field-label' >Start of Week</span>" +
			"<span class='b4c-field-input'>" +
				"<input type='radio' class='dayOfWeek pref' name='dayOfWeek' id='dayOfWeekSat' value='6'>" +
					"<label for='dayOfWeekSat'>Saturday</label> <br>" +
				"<input type='radio' class='dayOfWeek pref' name='dayOfWeek' id='dayOfWeekSun' value='0'>" +
					"<label for='dayOfWeekSun'>Sunday</label> <br>" +
				"<input type='radio' class='dayOfWeek pref' name='dayOfWeek' id='dayOfWeekMon' value='1'>" +
					"<label for='dayOfWeekMon'>Monday</label> <br>" +
			"</span>" +
		"</label>" +
		"<div style='clear:both'></div>" +
		"<div class='b4c-field'>" +
			"<label>" +
				"<span class='b4c-field-label'>Default Meeting Time</span>" +
				"<span class='b4c-field-input'>" +
					"<input type='radio' class='defaultMeetingTime pref' name='defaultMeetingTime' id='default30' value='30' > <label for='default30'>30 minutes</label> <br>" +
					"<input type='radio' class='defaultMeetingTime pref' name='defaultMeetingTime' id='default60' value='60' > <label for='default60'>60 minutes</label> <br>" +
				"</span>" +
			"</label>" +
		"</div>" +
		"<div style='clear:both'></div>" +
		"<div class='b4c-field'>"+
			"<span class='b4c-field-label'>Date Format</span>" +
			"<span class='b4c-field-input'>" +
			"<select class='customDateFormat pref updateSampleFormat by-input-primary'>" +
				"<option id='customDate1' value='dddd, MMM d' dropdownTextFormat='MMM d'></option>" +
				"<option id='customDate2' value='dddd, M/d' dropdownTextFormat='M/d'></option>" +
				"<option id='customDate3' value='dddd, d MMM' dropdownTextFormat='d MMM'></option>" +
				"<option id='customDate4' value='dddd, d/M' dropdownTextFormat='d/M'></option>" +
			"</select>" +
			"</span>" +
		"</div>" +
		"<div style='clear:both'></div>" +
		"<br />" +
		"<div class='b4c-field'>"+
			"<span class='b4c-field-label'>Time format</span>" +
			"<span class='b4c-field-input'>" +
				"<select class='customTimeFormat pref updateSampleFormat by-input-primary'>" +
					"<option id='customTime1' value='h:mm tt' dropdownTextFormat='h:mm tt'></option>" +
					"<option id='customTime2' value='H:mm' dropdownTextFormat='H:mm'></option>" +
				"</select>" +
			"</span>" +
		"</div>" +
		"<div style='clear:both'></div>" +
		"<br />" +
		"<div class='b4c-field'>"+
			"<span class='b4c-field-label'>&nbsp;</span>" +
			"<span class='b4c-field-input'>" +
				"<label>" +
					"<input class='customTimeZone pref updateSampleFormat by-input-primary' checked='checked' type='checkbox' name='customTimeZone' value='True' />" +
					"<span>Include time zone (EST, GMT, etc.)</span>" +
				"</label>" +
			"</span>" +
		"</div>" +
		"<div style='clear:both'></div>" +
		"<div class='b4c-field'>" +
			"<span class='b4c-datetime-sample'>Sample event text in your format: <span id='sampleText'></span> </span>" +
		"</div>" +
		"<div style='clear:both'></div>" +
		"<br/>" +
		syncSettings +
	"</div>";

	var calendar_sync_option = "<tr>" +
		"<td>" +
			'<input type="checkbox" name="calendar_sync" class="calendar_sync" value="{{calendar.id}}" /> </td>' +
		"<td class='bcalSummary'>{{calendar.summary}}<br /></td>" +
		"</tr>" ;

	var calendar_default_to_add = 
		"<option class='bcalSummary' value='{{calendar.id}}' selected='selected'> {{calendar.summary}} </option>";

	var display_meetings = {
		dialog:
			'<div class="bcal_dialogdiv">' +
				'<div class="addEventContainer" style="display:none;"></div>' +
				'<div id="boomerang-calendar-display">' +
					'<div class="eventDetailsContainer"></div>' +
				'</div>' +
				'<div class="by-helper-clearfix b4c-times-holder">' +
					'<div class="detectedTimesContainer">' +
						'<div class="detectedTimesHeader">Times detected in email</div>' +
						'<ol class="detected-times"></ol> ' +
					'</div>' +
					'<div class="suggestedTimes">' +
						'<div class="suggestedTimesLabel">Propose Alternate Times</div>' +
						'<ol class="suggestedTimeSlots"></ol>' +
						'<div class="b4c-proposed-time-controls">' +
							'<span class="suggestAlternativesLink"><button class="by-button-primary suggestAlternatives" href="#">Generate email response</button></span>' +
							'<span class="clearAllLink"><button class="clearSuggested" href="#">Clear All</button></span>' +
							'<div class="tentative_block">' +
								'<label>' +
									'<input id="b4c_mark_tentative_cb" type="checkbox" value="0"/> Reserve time slots in my calendar ' +
									'<span class="by-icon by-icon-info" title="Boomerang Calendar can add the times you suggested to your calendar and mark them as tentative. When you confirm one of the times and add the meeting to your calendar, we\'ll prompt you to clear the other times."/>' +
								'</label>' +
								'<div id="b4c_tentative_event_title" style="display:none;">' +
									'Event Title * <input id="b4c_tentative_event_title_input" placeholder="Enter event title" size="35"/>' +
								'</div>' +
							'</div>' +
						'</div>' +
					'</div>' +
				'</div>' +
			'</div>'
		,
		detected_time:
			'<li class="addDetectedEvent">' +
				'<span class="b4c-start-time"/> &ndash; <span class="b4c-end-time" />' +
			'</li>'
		,
		proposed_time:
			'<li class="proposedTime">' +
				'<span class="b4c-proposed-time-idx"/>' +
				'<span class="bcalEventDetails">' +
					'<span class="b4c-start-time"/> &ndash; <span class="b4c-end-time" />' +
				'</span>' +
				'<a class="proposedTimeCancel by-icon by-icon-closethick" href="#">x</a>' +
			'</li>'
		,
	};

	exports.suggestMeeting = suggestMeeting;
	exports.addEvent = addEvent;
	exports.customDateTimeSettings = customDateTimeSettings;
	exports.syncSettings = syncSettings;
	exports.allSettings = allSettings;
	exports.calendar_sync_option = calendar_sync_option;
	exports.calendar_default_to_add = calendar_default_to_add;
	exports.eventTooltip = eventTooltip;
	exports.display_meetings = display_meetings;
})(jQuery, window.by.template || (window.by.template = {}));
